#!/bin/sh

determineVersion() {
    local d="${1}/maven-archiver"
    if [ ! -d ${d} ]; then
        echo "Invalid directory: ${d}"
        exit $err_status
    fi
    local f="${d}/pom.properties"
    version=$(sed '/^\#/d' ${f} | grep "version"  | tail -n 1 | cut -d "=" -f2-)
    if [ -z "${version}" ]; then
        echo "Version could not be determined"
        exit $err_status
    fi
}

upload() {
    if [ ! -d ${1} ]; then
        echo "Invalid directory: ${1}"
        exit $err_status
    fi
    rsync -rv --protocol=28 "${1}" ${rsyncUser}@${rsyncBaseUrl}:${rsyncBasePath}/maven/${2}
    rsync -rv --protocol=28 "${1}" ${rsyncUser}@${rsyncBaseUrl}:${rsyncBasePath}/maven/latest
}

# Base URL
rsyncBaseUrl=filemgmt.jboss.org
rsyncBasePath=/docs_htdocs/wildfly/plugins/

baseDir=$(readlink -m .)
echo $baseDir

#rsync -rv --protocol=28 ./ wildfly@filemgmt.jboss.org:/docs_htdocs/wildfly/plugins/maven/
err_status=128
exit_status=0

modules=( "core" "plugin" )

while [ "$#" -gt 0 ]
do
    case "${1}" in
        -u|--user)
            if [ -z "${2}" ]; then
                echo "A user must be provided with option -u"
                exit ${err_status}
            fi
            rsyncUser="${2}"
            shift
            ;;
        *)
            rsyncUser="${1}"
            ;;
    esac
    shift
done

if [ -z "${rsyncUser}" ]; then
    echo "A user is required"
    exit ${err_status}
fi

#for module in ${modules[*]}; do
#    d="${baseDir}/plugin/target"
#    determineVersion "${d}"
#    rsync -rv --protocol=28 "${d}/site" ${rsyncUser}@${rsyncBaseUrl}:${rsyncBasePath}/maven/${version}
#    rsync -rv --protocol=28 "${d}/site" ${rsyncUser}@${rsyncBaseUrl}:${rsyncBasePath}/maven/latest
#done

echo "This does not currently work correctly"
exit -1

pluginDir="${baseDir}/plugin/target"
determineVersion "${pluginDir}"
upload "${pluginDir}/site" "${version}"

coreDir="${baseDir}/core/target"
determineVersion "${pluginDir}"
upload "${coreDir}/site/apidocs" "${version}"